# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from digitaleye_msgs/MvSafetyStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import digitaleye_msgs.msg

class MvSafetyStatus(genpy.Message):
  _md5sum = "fc99f4e03d54d54621918e61a3a38070"
  _type = "digitaleye_msgs/MvSafetyStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Current safety status of the Managed Volume

# overall safety status, use SS_ constants in SafetyStatus
uint32 safety_status

digitaleye_msgs/SafetyStatus[] zones_status

================================================================================
MSG: digitaleye_msgs/SafetyStatus
# Safety status

# zone id
uint32 id

# overall safety status, use SS_ below
uint32 safety_status

uint32 SS_SAFE = 0
uint32 SS_UNSAFE = 1
"""
  __slots__ = ['safety_status','zones_status']
  _slot_types = ['uint32','digitaleye_msgs/SafetyStatus[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       safety_status,zones_status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MvSafetyStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.safety_status is None:
        self.safety_status = 0
      if self.zones_status is None:
        self.zones_status = []
    else:
      self.safety_status = 0
      self.zones_status = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.safety_status
      buff.write(_get_struct_I().pack(_x))
      length = len(self.zones_status)
      buff.write(_struct_I.pack(length))
      for val1 in self.zones_status:
        _x = val1
        buff.write(_get_struct_2I().pack(_x.id, _x.safety_status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.zones_status is None:
        self.zones_status = None
      end = 0
      start = end
      end += 4
      (self.safety_status,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.zones_status = []
      for i in range(0, length):
        val1 = digitaleye_msgs.msg.SafetyStatus()
        _x = val1
        start = end
        end += 8
        (_x.id, _x.safety_status,) = _get_struct_2I().unpack(str[start:end])
        self.zones_status.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.safety_status
      buff.write(_get_struct_I().pack(_x))
      length = len(self.zones_status)
      buff.write(_struct_I.pack(length))
      for val1 in self.zones_status:
        _x = val1
        buff.write(_get_struct_2I().pack(_x.id, _x.safety_status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.zones_status is None:
        self.zones_status = None
      end = 0
      start = end
      end += 4
      (self.safety_status,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.zones_status = []
      for i in range(0, length):
        val1 = digitaleye_msgs.msg.SafetyStatus()
        _x = val1
        start = end
        end += 8
        (_x.id, _x.safety_status,) = _get_struct_2I().unpack(str[start:end])
        self.zones_status.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
